with Ada.Text_Io;
use Ada.Text_Io;
with System;
procedure Size_Test is
    type Test_Type1 is (A, B, C, D, E, F, G, H, I, J, K);
    -- Test_Type1'Size will be 4, the minimum number of bits required.

    type Test_Type2 is (A, B, C, D, E, F, G, H, I, J, K);
    for Test_Type2'Size use 16;
    -- Test_Type2'Size will be 16, as fixed by the size clause.

    type Test_Type3 is (A, B, C, D, E, F, G, H, I, J, K);
    Test3 : Test_Type3;
    -- Test3'Size will be System.Storage_Unit (typically 8).

    type Test_Type4 is (A, B, C, D, E, F, G, H, I, J, K);
    for Test_Type4'Size use 16;
    Test4 : Test_Type4;
    -- Test4'Size will be 16.

    type Test_Type5 is (A, B, C, D, E, F, G, H, I, J, K);
    subtype Sub_Test_Type5 is Test_Type5 range A .. C;
    -- Sub_Test_Type5'Size will be 2, the minimum number of bits required.

    type Test_Type6 is (A, B, C, D, E, F, G, H, I, J, K);
    for Test_Type6'Size use 16;
    subtype Sub_Test_Type6 is Test_Type6 range A .. C;
    Sub_Test6 : Sub_Test_Type6;
    -- Sub_Test_Type6'Size will be 2, the minimum number of bits required.
    -- Sub_Test6'Size will be 16, due to the size clause on Test_Type6.

begin
    Put_Line ("System.Storage_Unit is: " & Integer'Image (System.Storage_Unit));
    Put_Line ("Test_Type1 size is:     " & Integer'Image (Test_Type1'Size));
    Put_Line ("Test_Type2 size is:     " & Integer'Image (Test_Type2'Size));
    Put_Line ("Test3 size is:          " & Integer'Image (Test3'Size));
    Put_Line ("Test4 size is:          " & Integer'Image (Test4'Size));
    Put_Line ("Sub_Test_Type5 size is: " & Integer'Image (Sub_Test_Type5'Size));
    Put_Line ("Sub_Test_Type6 size is: " & Integer'Image (Sub_Test_Type6'Size));
    Put_Line ("Sub_Test6 size is:      " & Integer'Image (Sub_Test6'Size));
end Size_Test;

